package cz.muni.fi.pa165.model;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.view.client.ProvidesKey;

/**
 * Object Type representing Book
 *
 * @author Pavel Zlámal
 */
public class Book extends JavaScriptObject {

	public static final ProvidesKey<Book> BOOK_KEY_PROVIDER = new ProvidesKey<Book>(){
		@Override
		public Object getKey(Book item) {
			return (item != null) ? item.getId() : null;
		}
	};

	protected Book() {}

	/**
	 * Get ID.
	 *
	 * @return ID of book.
	 */
	public final native int getId() /*-{
		return this.id;
	}-*/;

	/**
	 * Set ID.
	 *
	 * @param id ID of book to set.
	 */
	public final native void setId(int id) /*-{
		this.id = id;
	}-*/;

}