<%@ page contentType="text/html;charset=UTF-8" pageEncoding="utf-8" session="false" %>
<html>
<head>
    <title>Book ajax</title>
    <style>
        table.mytable { border-collapse: collapse; margin: 10px; }
        table.mytable th, table.mytable td {  border: solid 1px black; padding: 4px; }
    </style>
    <script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
    <!-- call after document DOM is ready -->
    <script>
        function getContextPath() {
            return $('#contextPath').val();
        }

        $(document).ready(function () {
            load_books();
        });
        function load_books() {

            $.ajax({
                type: 'GET',
                url: getContextPath()+'/mvc/book/list',
                success: function (data) {
                    console.log('got data for list');
                    console.log(data);
                    var tab = '';
                    $.each(data,function(idx,book) {
                        tab+='<tr>' +
                                '<td>'+book.id+'</td>' +
                                '<td>'+book.name+'</td>'+
                                '<td>'+book.author+'</td>'+
                                '<td>'+book.paperback+'</td>'+
                                '<td>'+book.price+'</td>'+
                                '<td>'+book.color+'</td>'+
                                '<td><button onclick="delete_book('+book.id+')">delete</button></td>'+
                                '<td><button onclick="edit_book('+book.id+')">edit</button></td>'+
                                '</tr>';
                    });
                    $('#books').html(tab);
                }
            });
        }

        function delete_book(id) {
            $.ajax({
                type: 'DELETE',
                url: getContextPath()+'/mvc/book/delete/'+id,
                success: function (data) {
                    console.log('got data for delete');
                    console.log(data);
                    load_books();
                    $('#msgarea').html('book '+data.id+' deleted');
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    $('#msgarea').html('error when deleting book: '+textStatus+' / '+errorThrown);
                }
            });
        }

        function edit_book(id) {
            $.ajax({
                type: 'GET',
                url: getContextPath()+'/mvc/book/get/'+id,
                success: function (data) {
                    console.log('got data for edit');
                    console.log(data);
                    $('#bookId').val(data.id);
                    $('#bookName').val(data.name);
                    $('#bookAuthor').val(data.author);
                    $('#bookPaperback').prop('checked',data.paperback);
                    $('#bookPrice').val(data.price);
                    $('#bookColor').val(data.color);
                    $('#msgarea').html('loaded book '+data.id+' to form');
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    $('#msgarea').html('error when getting book: '+textStatus+' / '+errorThrown);
                }
            });
        }

        function update_book() {
            $.ajax({
                type: 'POST',
                url: getContextPath()+'/mvc/book/update',
                contentType: "application/json",
                data: JSON.stringify({
                    'id': parseInt($('#bookId').val()),
                    'name': $('#bookName').val(),
                    'author': $('#bookAuthor').val(),
                    'paperback': $('#bookPaperback').prop('checked'),
                    'price': $('#bookPrice').val(),
                    'color': $('#bookColor').val()
                }),
                statusCode: {
                    404: function(a,b,c) {
                        console.log("got 404");
                        $('#msgarea').html('book not found');
                    },
                    422: function(a,b,c) {
                        console.log("got 422");
                        console.log(a.responseJSON.fieldErrors);
                        var msg='';
                        $.each(a.responseJSON.fieldErrors,function(key,value){
                            msg+='<br>'+key+": "+value;
                        });
                        $('#msgarea').html(msg);
                    }
                }
            }).done(function (data) {
                console.log('success for update');
                console.log(data);
                load_books();
                $('#msgarea').html('book updated');
            });
        }

        function create_book() {
            $('#bookId').val('0');
            update_book();
        }
    </script>

</head>
<body>

<div id="msgarea"></div>

<table class="mytable" id="books">

</table>

<br><button onclick="load_books()">Load table</button>
<br><button onclick="delete_book(100)">Delete non-existent</button>
<br><a href="${pageContext.request.contextPath}/mvc/book/list">JSON list</a>
<br>
<br><button onclick="create_book()">Create book</button>
<br><button onclick="update_book()">Update book</button>

<input id="contextPath" value="${pageContext.request.scheme}://${pageContext.request.serverName}:${pageContext.request.serverPort}${pageContext.request.contextPath}">

<form id="f1" name="f1" onsubmit="submit_book()">
    <table>
        <tr>
            <td>id</td>
            <td><input type="text" name="bookId" id="bookId" value="0"></td>
        </tr>
        <tr>
            <td>name</td>
            <td><input type="text" name="bookName" id="bookName"></td>
        </tr>
        <tr>
            <td>author</td>
            <td><input type="text" name="bookAuthor" id="bookAuthor"></td>
        </tr>
        <tr>
            <td>paperback</td>
            <td><input type="checkbox" name="bookPaperback" id="bookPaperback"></td>
        </tr>
        <tr>
            <td>price</td>
            <td><input type="text" name="bookPrice" id="bookPrice"></td>
        </tr>
        <tr>
            <td>color</td>
            <td><input type="text" name="bookColor" id="bookColor"></td>
        </tr>
    </table>
</form>

</body>
</html>
